﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework;

namespace StickyFingaz.Controls
{
    public class MouseCursor : Cursor
    {
        MouseState previousMouseState;
        bool isPlayerTwo;

        public MouseCursor(Game1 game, bool isPlayerTwo) : base(game)
        {
            this.isPlayerTwo = isPlayerTwo;
        }

        public override void Update(GameTime gameTime)
        {
            base.Update(gameTime);
   
            position = new Vector2(
                Mouse.GetState().X,
                Mouse.GetState().Y);

            MouseState mouseState = Mouse.GetState();

            if (isPlayerTwo)
            {
                this.isButtonDown = mouseState.RightButton == ButtonState.Pressed &&
                                    previousMouseState.RightButton == ButtonState.Released;
            }
            else
            {
                this.isButtonDown = mouseState.LeftButton == ButtonState.Pressed &&
                                    previousMouseState.LeftButton == ButtonState.Released;
            }

            previousMouseState = mouseState;
        }
    }
}
