﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;

namespace StickyFingaz.Controls
{
    public class XboxCursor : Cursor
    {
        private PlayerIndex playerIndex;
        private GamePadState previousGamepadState;

        public XboxCursor(Game1 game, PlayerIndex playerIndex)
            : base(game)
        {
            this.playerIndex = playerIndex;
        }

        public override void Update(GameTime gameTime)
        {
            GamePadState currentGamepadState = GamePad.GetState(this.playerIndex);

            isButtonDown = false;

            if (currentGamepadState.Buttons.A == ButtonState.Pressed &&
                previousGamepadState.Buttons.A == ButtonState.Released)
            {
                isButtonDown = true;
            }

            Viewport vp = this.Game.GraphicsDevice.Viewport;
            Vector2 movement = currentGamepadState.ThumbSticks.Left;
            movement.Y = -movement.Y;

            position += movement * 1200 * 
                gameTime.ElapsedGameTime.Milliseconds / 1000.0f;

            position.X = MathHelper.Clamp(position.X, vp.X, vp.X + vp.Width);
            position.Y = MathHelper.Clamp(position.Y, vp.Y, vp.Y + vp.Height);

            this.sprite.Position = position;

            previousGamepadState = currentGamepadState;
        }
    }
}
