﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StickyFingaz.Handlers;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace StickyFingaz.GameStates
{
    public class CreditsState : GameState
    {
        Sprite sprite;
        private float timeToScroll, timeElapsed;

        public CreditsState(Game1 game) : base(game)
        {
            sprite = TextSpriteHandler.GetInstance(game).CreateSprite(
                this.game.Content.Load<Texture2D>("Credits"),
                Vector2.Zero);

            sprite.Type = SpriteType.DESTINATION_RECTANGLE;
            sprite.Rectangle = new Rectangle(
                0, 0, 800, 2200);

            timeToScroll = 30000;
        }

        public override void Enter(GameState previousState)
        {
            TextSpriteHandler.GetInstance(game).scrollAmount = Vector2.Zero;
        }

        public override void Leave()
        {
        }

        public override void Draw(Microsoft.Xna.Framework.GameTime gameTime)
        {
            this.game.GraphicsDevice.Clear(Color.White);
        }

        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {
            timeElapsed += gameTime.ElapsedGameTime.Milliseconds;

            if(timeElapsed > timeToScroll)
            {
                timeElapsed = timeToScroll;
            }

            float amount = timeElapsed / timeToScroll;
            
            TextSpriteHandler.GetInstance(game).scrollAmount =
                Vector2.Lerp(
                    Vector2.Zero,
                    new Vector2(0, -1600),
                    amount);
        }
    }
}
