﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StickyFingaz.Handlers;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Audio;

namespace StickyFingaz.GameStates
{
    public class GameOverState : GameState
    {
        private Sprite sprite;
        private Cue cue;
        private bool isRed;

        public GameOverState(Game1 game, bool isRed)
            : base(game)
        {
            this.isRed = isRed;
        }

        public override void Enter(GameState previousState)
        {
            if (isRed)
            {
                sprite = TextSpriteHandler.GetInstance(game).CreateSprite(
                    this.game.Content.Load<Texture2D>("WinscreenRed"),
                    Vector2.Zero,false);
            }
            else
            {
                sprite = TextSpriteHandler.GetInstance(game).CreateSprite(
                    this.game.Content.Load<Texture2D>("WinscreenBlue"),
                    Vector2.Zero, false);
            }

            TextSpriteHandler.GetInstance(game).scrollAmount = Vector2.Zero;
            cue = SoundHandler.GetInstance().Play("win");
        }

        public override void Leave()
        {
            TextSpriteHandler.GetInstance(game).RemoveSprite(sprite);
            cue.Stop(AudioStopOptions.Immediate);
        }

        public override void Draw(Microsoft.Xna.Framework.GameTime gameTime)
        {
        }

        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {
            if (Mouse.GetState().LeftButton == ButtonState.Pressed)
            {
                this.game.ChangeState(new CreditsState(this.game));
            }

            if (GamePad.GetState(PlayerIndex.One).Buttons.Start == ButtonState.Pressed)
            {
                this.game.ChangeState(new CreditsState(this.game));
            }
        }
    }
}
