using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Graphics;

namespace StickyFingaz.GameStates
{
  public abstract class GameState
  {
    #region Properties
    protected bool isInitialized;
    protected Game1 game;
    protected KeyboardState previousKeyboardState;

    public Game1 Game
    {
      get { return game; }
      set { game = value; }
    }
    #endregion

    public GameState(Game1 game)
    {
      this.Game = game;
    }

    public virtual void Enter(GameState previousState)
    {
      if (!isInitialized)
      {
        Initialize();
      }
    }

    public virtual void Initialize()
    {
      this.isInitialized = true;
    }

    public abstract void Leave();


    public abstract void Draw(GameTime gameTime);
    public abstract void Update(GameTime gameTime);
  }
}
