﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Input;
using StickyFingaz.Handlers;
using System.Threading;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace StickyFingaz.GameStates
{
    public class TitleGameState : GameState
    {
        Cue music;
        Sprite sprite;

        public TitleGameState(Game1 game)
            : base(game)
        { }

        public override void Enter(GameState previousState)
        {
            music = SoundHandler.GetInstance().Play("titlescreen");
            sprite = TextSpriteHandler.GetInstance(game).CreateSprite(
                this.game.Content.Load<Texture2D>("Splash"),
                Vector2.Zero);
        }

        public override void Leave()
        {            
            TextSpriteHandler.GetInstance(this.game).RemoveSprite(sprite);
            music.Stop(AudioStopOptions.Immediate);
            Thread.Sleep(400);
            SoundHandler.GetInstance().Play("startgame");
        }

        public override void Draw(Microsoft.Xna.Framework.GameTime gameTime)
        {
        }

        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {
            if (Mouse.GetState().LeftButton == ButtonState.Pressed)
            {
                this.game.ChangeState(new MainGameState(this.game));
            }

            if (GamePad.GetState(Microsoft.Xna.Framework.PlayerIndex.One).Buttons.Start == ButtonState.Pressed)
            {
                this.game.ChangeState(new MainGameState(this.game));
            }
        }
    }
}
