﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;
using StickyFingaz.Handlers;
using Microsoft.Xna.Framework.Graphics;
using FarseerGames.FarseerPhysics.Dynamics;
using FarseerGames.FarseerPhysics.Collisions;

namespace StickyFingaz.Level
{
    class BackgroundObject : GameObject
    {
        private Sprite sprite;


        public BackgroundObject(Game1 game, 
                           Vector2 position_, Vector2 scale_, float rotation_,
                           string textureName) 
            : base(game, position_,
                           scale_.X, rotation_)
        {
            Texture2D t2d = game.Content.Load<Texture2D>(textureName);
            sprite = TextSpriteHandler.GetInstance(game).CreateSprite(
                t2d,
                Vector2.Zero);
            sprite.Scale = scale_;
            sprite.Depth = 0.05f;
            sprite.Origin = new Vector2(t2d.Width / 2 * scale_.X, t2d.Height / 2 * scale_.Y);
            //use the body factory to create the physics body
        }

        public override void Draw(Microsoft.Xna.Framework.GameTime gameTime)
        {
        }

        public override void Update(Microsoft.Xna.Framework.GameTime gameTime)
        {

        }
    }
}
