﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace StickyFingaz.Level.Enemies
{
    public class EnemySpawnPoint : GameObject
    {
        private enum EnemySpawnPointState
        {
            ESPS_SPAWNING, ESPS_IDLE
        };
        private EnemySpawnPointState state;
        private int timeToSpawn, timeElapsed;
        private Level level;
        private EnemyType enemyType;
        private bool isNeedSpawn;
        private Enemy enemy;
        
        public EnemySpawnPoint(Game1 game, Vector2 position, Level level, EnemyType type)
            : base(game, position, 1, 0)
        {
            this.level = level;
            enemyType = type;
        }

        public void Spawn()
        {
            enemy = new EnemyHound(this.game, this, this.position, new Vector2(0.15f), enemyType);
            level.AddEnemy(enemy);

            state = EnemySpawnPointState.ESPS_SPAWNING;
            timeElapsed = 0;
            timeToSpawn = game.Random.Next(5000, 10000);
        }

        public override void Draw(GameTime gameTime)
        {            
        }

        public void Reset()
        {
            if (enemy != null)
                enemy.Remove();
        }

        public override void Update(GameTime gameTime)
        {
            if (enemy == null)
                return;

            switch (state)
            {
                case EnemySpawnPointState.ESPS_SPAWNING:
                    timeElapsed += gameTime.ElapsedGameTime.Milliseconds;
                    if (timeElapsed > 2000)
                    {
                        timeElapsed = 0;
                        enemy.SetScale(new Vector2(0.15f));
                        state = EnemySpawnPointState.ESPS_IDLE;
                        return;
                    }

                    enemy.SetScale(Vector2.Lerp(Vector2.Zero, new Vector2(0.15f),
                        timeElapsed / 2000.0f));

                    break;
                case EnemySpawnPointState.ESPS_IDLE:
                    /*if (enemy == null)
                    {
                        timeElapsed += gameTime.ElapsedGameTime.Milliseconds;
                        if (timeElapsed >= timeToSpawn)
                        {
                            Spawn();
                        }
                    }*/
                    break;
            }

        }
    }
}
